#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "options.h"
#include "fail.h"

static const char *progname;

static const char *
base_name(const char *pathname)
{
	const char *base, *pch;
	char ch;

	for (pch = base = pathname; (ch = *pch++) != '\0'; )
		if (ch == '/')
			base = pch;
	return base;
}

static void
usage_info(void)
{
	printf(
	  "Usage: %s --help\n"
	  "       %s --version\n"
	  "       %s source.nef destination.jpg\n\n"
	  "This utility copies the EXIF data from the source file (NEF)\n"
	  "to the destination file (JPEG). Thumbnails are not copied.\n",
	  progname,progname,progname);
	exit(0);
	/* NOT REACHED */
}

static void
version_info(void)
{
	printf(
	  "%s version 0.1 - Copyright (C)2005 by Vlado Potisk\n\n"
	  "This program is free software released under the terms of the\n"
	  "GNU General Public License. There is no warranty, use it at\n"
	  "your own risk.\n\n"
	  "Visit http://www.clex.sk/cpexif/ for more information.\n",
	  progname);
	exit(0);
	/* NOT REACHED */
}

extern char **
process_options(int ac, char **av)
{
	progname = base_name(av[0]);
	if (ac > 1 && strcmp(av[1],"--help") == 0)
		usage_info();
	if (ac > 1 && strcmp(av[1],"--version") == 0)
		version_info();
	if (ac != 3)
		fail_prog("Incorrect usage. "
		  "Try '%s --help' for more information",progname);
	return av + 1;
}
